<?

function outputcss($arr) {
  return $css=trim("

a:link { 
  color:$arr[linkcolour];
  text-decoration:none;
  font-weight:bold;
}

a:visited {
  color:$arr[vlinkcolour];
  text-decoration:none;
  font-weight:bold;
}

a:hover { 
  color:$arr[hlinkcolour];
  text-decoration:underline;
  font-weight:bold;
}

body {
  background-color:$arr[bodybgcolour];
  color:$arr[textcolour];
}

table {
  color:$arr[textcolour];
}
  
body,table,input,select {
  font-family:$arr[fontfamily];
  font-size:$arr[fontsize];
}

#box {
  border:$arr[tablebordersize] solid $arr[tablebordercolour];
  background-color:$arr[tablebgcolour];
  padding:3px;
  width:100%;
}

#box img {
  vertical-align:middle;
}

#icons {
  margin-top:3px;
}

#icons img {
  vertical-align:middle;
}

#imagetable td {
  background-color:$arr[cellbgcolour];
  padding:15px;
  border:$arr[cellbordersize] solid $arr[cellbordercolour];
  width:{$arr[cellwh][0]}px;
  height:{$arr[cellwh][1]}px;
}

#imagetable img {
  border:$arr[imagebordersize] solid $arr[imagebordercolour];
}

#imagetable .asis {
  border:0px;
  margin:0px;
}

.caption {
  font-weight:bold;
  margin-top:15px;
  text-align:center;
}

#caption {
  text-align:center;
  margin-top:5px;
}

form {
  margin:0px;
}
  ");
}

function savecontents($file,$contents) {
  $fh=fopen($file,"w+");
  $w=fwrite($fh,strip_tags($contents));
  $fh=fclose($fh);

  if ($w) {
    return 1;
  } else {
    echo "<b>Error</b>: $file was not saved.";
    return 0;
  }
}

function img_rotate($imagefile,$degrees) {
  global $convert,$parent,$imagedir;

  $imagefile=stripslashes($parent.$imagedir."/".$imagefile);

  if (is_file("$imagefile")) {
    $c="$convert -verbose -quality 100 -rotate $degrees \"$imagefile\" \"$imagefile\"";
    $e=exec($c);
  } else {
    echo "<center><b>Error:</b> Unable to convert $parent.$imagedir/$imagefile!</center>";
    return 0;
  }

  if ($e) {
    unlink(stripslashes(dirname($imagefile)."/cache/thumbnail-".basename($imagefile)));
    unlink(stripslashes(dirname($imagefile)."/cache/slide-".basename($imagefile)));
    return 1;
  }  
}

?>
