<?

function estert($str) {
  $str=strtoupper($str);
  $arr=explode(" ",strip_tags(ereg_replace(" +"," ",trim($str))));
  return array_unique($arr);
}

function get_ip() {
  if ($_SERVER[HTTP_X_FORWARDED_FOR]) {
    return $_SERVER[HTTP_X_FORWARDED_FOR];
  } else {
    return $_SERVER[REMOTE_ADDR];
  }
}
 
function admin_ip_access() {
  if (!$_SESSION[admin][ips]) { return 0; }

  foreach ($_SESSION[admin][ips] as $ip) {
    if (!$ip) {
      return 0;
    }

    if (ereg("^$ip",get_ip())) {
      return 1;
    }
  }
}

function load_theme() {
  global $themeconfigfile;
  $_SESSION[theme]=unserialize(base64_decode(file_get_contents($themeconfigfile)));
}

function load_prefs() {
  global $configfile;
  $_SESSION[admin]=unserialize(base64_decode(file_get_contents($configfile)));
}

function admin_access() {
  if ($_SESSION[loggedin]||admin_ip_access()) {
    return 1;
  } else {
    return 0;
  }
}

function limit_access() {
  global $valign;

  if (admin_access()) {
    return 1;
  } else {
    echo "<div id=\"box\">\n";
    echo "<center><b>Error:</b> You do not have the sufficient permission to view this page!<br>\n";
   
    if (!$_SESSION[admin][viewpassbox]) {
      echo "   <form method=\"POST\" action=\"login.php\">\n";
      echo "   Administration Login Password: <input type=\"password\" name=\"password\" $valign>\n";
      echo "   </form>\n"; 
    }

    echo "</div>\n\n";

    include_once("footer.php");
    die;
  }
}

function print_icons() {
  global $files,$i;

  echo "<div id=\"icons\" align=\"center\">\n";

  if ($_GET[i]==0) {
    echo "<img src=\"gif/first_off.gif\" alt=\"-\">\n";
    echo "<img src=\"gif/previous_off.gif\" alt=\"-\">\n";
  } else {
    echo "<a href=\"$_SERVER[PHP_SELF]?d=".rawurlencode($_GET[d])."&amp;i=0\"><img border=0 src=\"gif/first.gif\" alt=\"<<\"></a>\n";
    echo "<a href=\"$_SERVER[PHP_SELF]?d=".rawurlencode($_GET[d])."&amp;i=".($_GET[i]-1)."\"><img border=0 src=\"gif/previous.gif\" alt=\"<\"></a>\n";
  }

  if ($_GET[i]<count($files)-1) {
    end($files);
    echo "<a href=\"$_SERVER[PHP_SELF]?d=".rawurlencode($_GET[d])."&amp;i=".($_GET[i]+1)."\"><img border=0 src=\"gif/next.gif\" alt=\">\"></a>\n";
    echo "<a href=\"$_SERVER[PHP_SELF]?d=".rawurlencode($_GET[d])."&amp;i=".key($files)."\"><img border=0 src=\"gif/last.gif\" alt=\">>\"></a>\n";
  } else {
    echo "<img src=\"gif/next_off.gif\" alt=\"-\">\n";
    echo "<img src=\"gif/last_off.gif\" alt=\"-\">\n";
  }

  echo "<a href=\"exif.php?d=".rawurlencode(rawurldecode($_GET[d]))."&amp;i=$_GET[i]&amp;\"><img style=\"vertical-align:middle\" src=\"gif/e.gif\" border=0 alt=\"E\"></a>\n";

  if (admin_access()) {
    echo "<a href=\"img_rotate.php?file=$_GET[d]/".$files[$_GET[i]]."&amp;degrees=90\"><img border=0 src=\"gif/rotate-cw.gif\" alt=\"Rotate Clockwise\"></a>\n";
    echo "<a href=\"img_rotate.php?file=$_GET[d]/".$files[$_GET[i]]."&amp;degrees=270\"><img border=0 src=\"gif/rotate-ccw.gif\" alt=\"Rotate Counter-Clockwise\"></a>\n";
  }



  echo "</div>\n\n";
}

function fntrim($string) {
  global $fnstrlen;

  if (strlen($string)>$fnstrlen) {
    return "[...".substr($string,-($fnstrlen-5))."]";
  } else {
    return $string;
  }
}

function create_cache_dir() {
  $dir=getcwd()."/cache";

  #echo "Attempting to create the following directory:\n";
  #echo "$dir\n\n";

  if (is_dir($dir)) {
    return 0;
  } else {
    mkdir($dir);
  }

  if (is_dir($dir)) {
    return 1;
  } else {
    die("Error creating $dir\n");
  } 
}

function img_slide_create($imagefile) {
  global $convert,$slidesize,$overwrite;

  $z=@getimagesize($imagefile);
  $y=explode("x",$slidesize);

  create_cache_dir();

  if (file_exists("slide-".basename($imagefile))) {
    rename("slide-".basename($imagefile),dirname($imagefile)."/cache/slide-".basename($imagefile));
  }


  if ($z[0]<=$y[0]&&$z[1]<=$y[1]) {
    $to=dirname($imagefile)."/cache/slide-".basename($imagefile);
    copy($imagefile,$to);
    return 1;
  }

  if (is_file(dirname($imagefile)."/cache/slide-".basename($imagefile))&&!$overwrite) {
    return 0;
  }

  $e="$convert -size $slidesize \"$imagefile\" -resize $slidesize +profile \"*\" \"".dirname($imagefile)."/cache/slide-".basename($imagefile)."\"";

  #echo $e."\n";

  flush();
  exec($e);
  flush();

  if (file_exists(dirname($imagefile)."/cache/slide-".basename($imagefile))) {
    return 1;
  } else {
    echo "Slide image not created for $imagefile\n";
  }
}


function img_thumbnail_create($imagefile) {
  global $convert,$thumbsize,$parent,$imagedir,$overwrite;

  create_cache_dir();

  if (file_exists("thumbnail-".basename($imagefile))) { 
    rename("thumbnail-".basename($imagefile),dirname($imagefile)."/cache/thumbnail-".basename($imagefile)); 
  }

  $z=@getimagesize($imagefile);
  $y=explode("x",$thumbsize);

  if ($z[0]<=$y[0]&&$z[1]<=$y[1]) {
    $to=dirname($imagefile)."/cache/thumbnail-".basename($imagefile);
    copy($imagefile,$to);
    return 1;
  }

  if (is_file(dirname($imagefile)."/cache/thumbnail-".basename($imagefile))&&!$overwrite) {
    return 0;
  }

  $e="$convert -size $thumbsize \"$imagefile\" -resize $thumbsize +profile \"*\" \"".dirname($imagefile)."/cache/thumbnail-".basename($imagefile)."\"";

  exec($e);

  if (file_exists(dirname($imagefile)."/cache/thumbnail-".basename($imagefile))) {
    return 1;
  } else {
    echo "<br><b>Error:</b> Unable to create a thumbnail image for $imagefile, please ensure that $parent$imagedir is readable and writable by your httpd user.<br><br>\n\n";

    if ($_SESSION) {
      include_once("footer.php");
      die;
    }
  }
}

$image_types=array(
 1=>"GIF",
 2=>"JPEG",
 3=>"PNG",
 4=>"SWF",
 5=>"PSD",
 6=>"BMP",
 7=>"TIFF_II",
 8=>"TIFF_MM",
 9=>"JPC",
 10=>"JP2",
 11=>"JPX",
 12=>"JB2",
 13=>"SWC",
 14=>"IFF",
 15=>"WBMP",
 16=>"XBM"
);

?>
