<?

include_once("htmlcolours.php");

session_start();

include_once("config.php");
include_once("functions.php");

if (!$_SESSION[admin]) {
  load_prefs();
}

if (!$_SESSION[theme]) {
  load_theme();
}

if (!admin_access()) {
  include_once("header.php");
  limit_access();
} else {
  include_once("admin-functions.php");
}


$options[fontfamily]="Font Family";
$options[fontsize]="Font Size";
$options[tablebordersize]="Table Border Size";
$options[cellbordersize]="Table Cell Border Size";
$options[imagebordersize]="Picture Border Size";
$options[cellwh]="Cell Width and Height";
$options[bodybgcolour]="Site Background Colour";
$options[tablebgcolour]="Table Background Colour";
$options[cellbgcolour]="Table Cell Background Colour";
$options[textcolour]="Text Colour";
$options[linkcolour]="Link Colour";
$options[hlinkcolour]="Link Hover Colour";
$options[vlinkcolour]="Visited Link Colour";
$options[tablebordercolour]="Table Border Colour";
$options[imagebordercolour]="Image Border Colour";
$options[cellbordercolour]="Table Cell Border Colour";

if ($_POST[submit]=="Save Theme") {
  if (!$_POST[theme][fontsize]) {
    $_POST[theme][fontsize]=11;
  }

  foreach ($_POST[theme] as $k => $v) {
    $_POST[theme][$k]=trim(strip_tags($v));

    if (ereg("colour",$k)&&!ereg("value",$k)) {
      if (!$v) { $v=array_rand($htmlcolours,1); }

      $key=$k."value";

      if ($_POST[theme][$key]) {
        $_POST[theme][$k]=$_POST[theme][$key];
      } else {
        $_POST[theme][$k]=strtoupper($v);
      }
    }

    if (ereg("size",$k)) {
      if (!$v) { $v=0; }

      $v=ereg_replace("px","",$v);
      $_POST[theme][$k]=$v."px";
    }

    if ($k=="cellwh") {
      $_POST[theme][$k]=explode("x",$_POST[theme][$k]);
    }
  } 

  $s=savecontents($themeconfigfile,base64_encode(serialize($_POST[theme])));
  $s2=savecontents($stylesheet,outputcss($_POST[theme]));

  load_theme();

  echo "<meta http-equiv=refresh content=\"0; url=$_SERVER[REQUEST_URI]\">\n";
  die;
}

include_once("header.php");

echo "<div id=\"box\">\n";
echo "<a href=\"admin.php\">Administrative Options</b></a>\n";
echo "| <a href=\"theme.php\">Edit Theme</a>\n";
#echo "| <a href=\"editstyle.php\">Advanced CSS Editor</a>\n";
echo "<form method=\"POST\" action=\"$_SERVER[PHP_SELF]\">\n";
echo "<table>\n";

foreach ($options as $k => $v) {
  echo " <tr>\n";
  echo "  <td>$v:</td>\n";

  if (ereg("colour",$k)) {
    echo "  <td><input name=\"theme[$k]\" value=\"".$_SESSION[theme][$k]."\" maxlength=7></td>\n";

    if ($_SESSION[admin][colourboxes]) {
      echo "  <td>\n";
      echo "   <select name=\"theme[{$k}value]\">\n";

      foreach ($htmlcolours as $hk => $hv) {
        if ($_SESSION[theme][$k]==$hk) {
          echo " <option selected value=\"$hk\">$hv</option>\n";
        } else {
          echo " <option value=\"$hk\">$hv</option>\n";
        }
      }

      echo "   </select>\n";
      echo "  </td>\n";
    }
  } elseif (ereg("size",$k)) {
    echo "  <td><input name=\"theme[$k]\" value=\"".$_SESSION[theme][$k]."\" maxlength=2></td>\n";
  } elseif ($k=="cellwh") {
    echo "  <td><input name=\"theme[$k]\" value=\"".implode("x",$_SESSION[theme][$k])."\" maxlength=7></td>\n";
  } else {
    echo "  <td><input name=\"theme[$k]\" value=\"".$_SESSION[theme][$k]."\"></td>\n";
  }

  echo " </tr>\n";
}

if (!is_writable($stylesheet)) {
  $disabled=" disabled";
  $efile[]=basename($stylesheet);
}

if (!is_writable($themeconfigfile)) {
  $disabled=" disabled";
  $efile[]=basename($themeconfigfile);
}

echo " <tr>\n";
echo "  <td colspan=3><input$disabled name=\"submit\" type=\"submit\" value=\"Save Theme\" $valign>";

if ($s) {
  echo " Theme Saved: ".number_format((filesize($themeconfigfile)/1024),2)." KB</td>\n";
} else {

  if ($disabled) {
    if (count($efile)>1) {
      echo " $efile[0] & $efile[1] are not writable; save feature disabled.";
    } else {
      echo " $efile[0] is not writable; save feature disabled."; 
    }
  }

  echo "</td>\n";
}

echo " </tr>\n";
echo "</table>\n";
echo "</form>\n";
echo "</div>\n";

include_once("footer.php");

?>
